using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace Jeffz.PolymorphismInWSTypes
{
	public abstract class Employee
	{
		private int _Years;

		public int Years
		{
			get
			{
				return this._Years;
			}
			set
			{
				this._Years = value;
			}
		}

		public string RealStatus
		{
			get
			{
				return this.GetType().Name;
			}
		}

		public abstract int CalculateSalary();
	}

	public class Intern : Employee
	{
		public override int CalculateSalary()
		{
			return 2000;
		}
	}

	public class Vendor : Employee
	{
		public override int CalculateSalary()
		{
			return 5000 + 1000 * (Years - 1);
		}
	}

	public class FulltimeEmployee : Employee
	{
		public override int CalculateSalary()
		{
			return 12000 + 2000 * (Years - 1);
		}
	}
}